(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/Types.sig,v
   Comment: Modelling types which are shared along vsr.sml and Absyn.sml,
		CodGenCXXX.sml, etc
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   WARNING: Prior to v 1.2 the meaning of this file was different (these
   were types as used  in hvsr.sml). Only the name has been kept.

   Types.sig,v 1.11 2002/10/24 20:17:10 wasowski Exp
*)

signature Types = sig


  datatype simplety = 
		VoidT  | VoidPtrT | BoolT  | CharT   | UCharT |
		IntT   | Int8T    | Int16T | Int32T  | UIntT  | 
		UInt8T | UInt16T  | FloatT | DoubleT   
	
  datatype ty = 
	  SimpleType of simplety	
        | ArrayType  of simplety * int	(* cell type, size  *)

  (* type of variable (is_static, type) *)

  type vartype = bool * ty                 
  
  (* event: internal, params  *)
  
  type evtype = bool * simplety list	   
  
  (* function prototype *)

  type otype = simplety * simplety list  (* output: return, params   *)

  datatype value = ValI of int    (* for all integers, pointers and chars *)
		 | ValR of real 
		 | ValA of value list


  val defvalty : simplety -> value

  val int2real : int   -> value
  val bool2int : bool  -> value
  val val2bool : value -> bool
  val real2bool: real  -> bool

  val promote : value * value -> value * value 

  val getInt : value -> int

  val tyname : simplety -> string

  val mintysize : int -> int
  val uint_bysize : int -> simplety

end

