/* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/VSTypes.h,v
   Comment: Wrapper for stdint.h to provide VS state like names ints with fixed sizes.
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   In VS ver. 4.x there is a file with the same names which implements the same types
   without using stdint.h. This implementation was made to avoid copyright issues with 
   IAR and also because I think it is generally a good idea to use things provided by 
   ISO C99 standard.

   This will not work if your C compiler does not provide the types (or does not provide 
   typedefs for the types)

   VSTypes.h,v 1.6 2002/10/24 20:17:10 wasowski Exp
*/

#ifndef _scope_VSTYPES_H
#define _scope_VSTYPES_H

#include <stdint.h> /* C99 type definitions */

#define VS_TRUE  '\1'
#define VS_FALSE '\0'

typedef unsigned char	VS_BOOL;
typedef unsigned char	VS_UCHAR;
typedef signed char	VS_SCHAR;
typedef unsigned int	VS_UINT;
typedef signed int	VS_INT;
typedef float		VS_FLOAT;
typedef double		VS_DOUBLE;
typedef void		VS_VOID;
typedef void *		VS_VOIDPTR;

#ifdef INT8_MAX
typedef uint8_t		VS_UINT8;
typedef int8_t		VS_INT8;
#endif

#ifdef INT16_MAX
typedef uint16_t	VS_UINT16;
typedef int16_t		VS_INT16;
#endif

#ifdef INT32_MAX
typedef uint32_t	VS_UINT32;
typedef int32_t		VS_INT32;
#endif



#endif /* _scope_VSTYPES_H */
